package cn.net.caoyao.cpzshandset.service.presenter.impl.warehouse.in.commonfarmers;

import java.util.ArrayList;
import java.util.List;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.view.View;
import android.widget.Toast;
import cn.net.caoyao.cpzshandset.bean.ConfigBean;
import cn.net.caoyao.cpzshandset.bean.WarehouseBean;
import cn.net.caoyao.cpzshandset.common.config.HandsetOperation;
import cn.net.caoyao.cpzshandset.common.config.HandsetVersionConstant;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.common.util.NetWorkUtils;
import cn.net.caoyao.cpzshandset.service.bll.SingleLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.UploadStatusBll;
import cn.net.caoyao.cpzshandset.service.bll.WarehouseBll;
import cn.net.caoyao.cpzshandset.service.bll.config.ConfigBll;
import cn.net.caoyao.cpzshandset.service.presenter.OptionHisListStyleConstact;
import cn.net.caoyao.cpzshandset.service.presenter.base.impl.OptionHisListStyleConstactImpl;
import cn.net.caoyao.cpzshandset.service.thread.ThreadPoolManager;
import cn.net.caoyao.cpzshandset.service.thread.impl.common.CommonCheckLabelThread;
import cn.net.caoyao.cpzshandset.service.thread.impl.common.CommonSubmitAllWarehouseThread;
import cn.net.caoyao.cpzshandset.ui.activity.SingleLabelScannerActivity;
import cn.net.caoyao.cpzshandset.ui.activity.WarehouseConfigActivity;
import cn.net.caoyao.cpzshandset.ui.adapter.WarehouseHisListAdapter;
import cn.net.caoyao.cpzshandset.ui.dialog.OperationDialog;
import cn.net.caoyao.cpzshandset.ui.dialog.TipsDialog;
import cn.net.caoyao.cpzshandset.ui.dialog.OperationDialog.DClick;
import cn.net.caoyao.cpzshandset.ui.dialog.TipsDialog.DSure;
import cn.net.caoyao.cpzshandset.ui.weight.DialogUtils;
import cn.net.handsetlib.utils.ReadDeviceIDUtil;

public class CommonFarmersInWarehouseListPresenter extends OptionHisListStyleConstactImpl{
	private final OptionHisListStyleConstact.View hisView;
	private Context context;
	private WarehouseHisListAdapter adapter;
//	private WarehouseHisListArrayAdapter adapter;
	private List<WarehouseBean> beans = new ArrayList<>();
	private int currentHansetVersion = HandsetVersionConstant.HANDSET_UNIVERSAL_VERSION_MODE_FARMERS;
	private HandsetOperation option_type = HandsetOperation.OPERATION_IN_WAREHOUSE_CONSTANT;
	private WarehouseBll bll;
	private SingleLabelBll labelBll;
	private ConfigBll configBll;
	private UploadStatusBll uploadStatusBll;
	private OperationDialog operationDialog;
	private TipsDialog tipsDialog;
	private ProgressDialog bProgressDialog = null;
	private Handler mHandler = new Handler(){
		public void handleMessage(android.os.Message msg) {
			switch (msg.what) {
			case RequestConstant.SUBMIT_ALL_WAREHOUSE_COMPLETE:
				dismissProgress();
				onResume();
				break;
			case RequestConstant.REQUEST_FAIL:
				//请求失败
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("请求失败！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT:
				//超时
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("请求超时！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PROT01_LOGIN_FAIL:
				//登录失败
				if (!checkViewAvailable())return;
				dismissProgress();
				String errorMsg = msg.obj.toString();
				int errorCode = msg.arg1;
				hisView.showMsgToast(errorMsg + errorCode, Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_CHECK_LABEL_SUCCESS:
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("检测标签信息成功，请在扫码界面中查看详细信息", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_CHECK_LABEL_FAIL:
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("检测标签信息失败", Toast.LENGTH_SHORT);
				break;
			}
		};
	};
	public CommonFarmersInWarehouseListPresenter(OptionHisListStyleConstact.View hisView, Context context) {
		super(hisView, context);
		this.hisView = hisView;
		this.context = context;
		start();
	}

	@Override
	public void start() {
		if (!checkViewAvailable())
			return;
		init();
		hisView.setPageTitle("入库列表");
		hisView.setMoreOptionText("新增");
		adapter = new WarehouseHisListAdapter(beans, labelBll, option_type.getOption());
//		adapter = new WarehouseHisListArrayAdapter(beans, labelBll, option_type);
		hisView.setAdapter(adapter);
	}

	private void init() {
		bll = new WarehouseBll(context);
		labelBll = new SingleLabelBll(context);
		configBll = new ConfigBll(context);
		uploadStatusBll = new UploadStatusBll(context);
	}

	@Override
	public boolean checkViewAvailable() {
		boolean b = false;
		if (hisView != null && context != null) {
			b = true;
		}
		return b;
	}
	
	public void dismissProgress() {
		if (bProgressDialog != null) {
			try {
				DialogUtils.dismissProgressDialog(bProgressDialog);
			} catch (Exception e) {
			}
		}
	}

	/**
	 * 提示正在更新数据
	 */
	protected void showProgressDialog(String titleStr, String tipsMsg) {
		bProgressDialog = DialogUtils.showProgressDialog(bProgressDialog, titleStr,
				tipsMsg, context);
	}

	@Override
	public Handler getHandler() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void onItemClickListener(int position) {
		if (!checkViewAvailable())
			return;
		if (beans.size() > 0) {
			Intent intent = new Intent(context, SingleLabelScannerActivity.class);
			intent.putExtra("optionMode", option_type);
			intent.putExtra("currentWarehouseBean", beans.get(position));
			context.startActivity(intent);
		}

	}

	@Override
	public void onItemLongClickListener(int position) {
		if (!checkViewAvailable())
			return;
		if (beans.size() > 0) {
			showOptionDialog(position);
		}

	}

	private void showOptionDialog(final int position) {
		if (operationDialog == null) {
			operationDialog = new OperationDialog(context);
		}
		operationDialog.show();
		operationDialog.setSearchViewVisiable(View.VISIBLE);
		operationDialog.setDClick(position, new DClick() {

			@Override
			public void modifyClick() {
				// 修改
				if (!checkViewAvailable())
					return;
				Intent intent = new Intent(context, WarehouseConfigActivity.class);
				intent.putExtra("optionMode", option_type);
				intent.putExtra("isCreate", false);
				intent.putExtra("currentHisId", beans.get(position).getId());
				context.startActivity(intent);
			}

			@Override
			public void delClick() {
				// 删除
				if (!checkViewAvailable())
					return;
				String msg = "本条数据还未上传\n\n是否确定删除入库数据？\n\n确定删除后\n\n该数据对应的所有信息都会被删除";
				showWarnTipDialog(msg, position);
			}

			@Override
			public void searckClick() {
				if (!checkViewAvailable()) return;
				if (!NetWorkUtils.isNetworkConnected(context)) {
					DialogUtils.showSetNetDialog(context);
					return;
				}
				ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHansetVersion);
				if (configBean == null) {
					hisView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
					return;
				}
				
				if (beans == null || beans.size() == 0) {
					hisView.showMsgToast("抱歉，当前的入库数据中都没有标签，不可上传", Toast.LENGTH_SHORT);
					return;
				}
				
				List<String> labels = labelBll.queryAllLabelStrById(option_type.getOption(), beans.get(position).getId());
				if (labels == null) {
					hisView.showMsgToast("抱歉，当前的入库数据中还没有标签，不可查询", Toast.LENGTH_SHORT);
					return;
				}
				
				if (labels.size() == 0) {
					hisView.showMsgToast("抱歉，当前的入库数据中还没有标签，不可查询", Toast.LENGTH_SHORT);
					return;
				}
				showProgressDialog("提示", "正在检测标签信息，请稍后……");
				long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
				ThreadPoolManager.getThreadPool().execute(new CommonCheckLabelThread(mHandler, deviceId, option_type, beans.get(position).getId(), labels, labelBll));												
			}
		});

	}

	protected void showWarnTipDialog(String msg, final int position) {
		if (tipsDialog == null) {
			tipsDialog = new TipsDialog(context);
		}
		tipsDialog.show();
		tipsDialog.setDelWarnView("警告", msg, position, false, new DSure() {

			@Override
			public void sureClick() {
				bll.deleteWarehouse(beans.get(position));
				beans = bll.queryWarehouseByOptionType(option_type.getOption());
				adapter.refreshData(beans);
				hisView.showMsgToast("删除成功！", Toast.LENGTH_SHORT);
			}
		});

	}

	@Override
	public void backBtnClick() {
		// TODO Auto-generated method stub

	}

	@Override
	public void moreOptionClick() {
		if (!checkViewAvailable())
			return;
		Intent intent = new Intent(context, WarehouseConfigActivity.class);
		intent.putExtra("optionMode", option_type);
		context.startActivity(intent);

	}

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {

	}

	@Override
	public void onResume() {
		beans = bll.queryWarehouseByOptionType(option_type.getOption());
		adapter.refreshData(beans);
	}

	@Override
	public void uploadAllHisList() {
		if (!checkViewAvailable()) return;
		ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHansetVersion);
		if (configBean == null) {
			hisView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			return;
		}
		if (beans == null || beans.size() == 0) {
			hisView.showMsgToast("抱歉，当前的入库数据中都没有标签，不可上传", Toast.LENGTH_SHORT);
			return;
		}
		
		List<WarehouseBean> valid = getValidWarehouse();
		if (valid == null || valid.size() == 0) {
			hisView.showMsgToast("抱歉，当前的入库数据中都没有标签，不可上传", Toast.LENGTH_SHORT);
			return;
		}
		showProgressDialog("提示", "正在提交入库信息，请稍后……");
		long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
		ThreadPoolManager.getThreadPool().execute(new CommonSubmitAllWarehouseThread(mHandler, deviceId, bll, labelBll, uploadStatusBll, option_type, valid));

	}
	
	private List<WarehouseBean> getValidWarehouse() {
		List<WarehouseBean> wls = bll.queryWarehouseByOptionTypeASC(option_type.getOption());
		List<WarehouseBean> valid = new ArrayList<>();
		for (WarehouseBean w : wls) {
			int count = labelBll.queryLabelCountById(option_type.getOption(), w.getId());
			if (count > 0) {
				valid.add(w);
			}
		}
		return valid;
	}

}

